/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "usb_device.h"
#include "event/modules/e_module_backlight.h"
#include "event/modules/e_module_core.h"
#include "event/modules/e_module_timers.h"
#include "event/modules/e_module_key.h"
#include "event/modules/e_module_keyboard.h"
#include "event/modules/e_module_report_codec.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USB_DEVICE_Init();
  /* USER CODE BEGIN 2 */
  struct e_module *mod_table[10];
  uint8_t stack[256];
  uint8_t qstack[2048];
  e_core_ctor(mod_table, 10, qstack, 2048, stack, 256);

  struct e_timer *timers[5];
  e_module_timers_ctor(timers, 5);

  struct e_module_backlight mod_backlight;
  e_pmod_backlight = &mod_backlight;
  e_module_backlight_ctor(&mod_backlight, "BCKL");

  struct e_module_key mod_switch_backlight;
  e_pmod_switch_backlight = &mod_switch_backlight;
  e_module_key_ctor(&mod_switch_backlight,
                      "SW_BCKL",
                      DRV_SWITCH_BACKLIGHT,
                      SIG_BACKLIGHT_ON,
                      SIG_BACKLIGHT_OFF,
                      e_pmod_backlight);

  struct e_module_keyboard mod_keyboard;
  e_pmod_keyboard = &mod_keyboard;
  e_module_keyboard_ctor(&mod_keyboard, "KEYBOARD");

  struct e_module_key mod_switch_layout;
  e_pmod_switch_layout = &mod_switch_layout;
  e_module_key_ctor(&mod_switch_layout,
                      "SW_LAYOUT",
                      DRV_SWITCH_LAYOUT,
                      SIG_LAYOUT_ON,
                      SIG_LAYOUT_OFF,
                      e_pmod_keyboard);

  struct e_module_key mod_switch_key_1;
  e_pmod_key_1 = &mod_switch_key_1;
  e_module_key_ctor(&mod_switch_key_1,
                      "SW_KEY_1",
                      DRV_KEY_1,
                      SIG_KEY_PRESSED,
                      SIG_KEY_RELEASED,
                      e_pmod_keyboard);

  struct e_module_key mod_switch_key_2;
  e_pmod_key_2 = &mod_switch_key_2;
  e_module_key_ctor(&mod_switch_key_2,
                      "SW_KEY_2",
                      DRV_KEY_2,
                      SIG_KEY_PRESSED,
                      SIG_KEY_RELEASED,
                      e_pmod_keyboard);

  struct e_module_key mod_switch_key_3;
  e_pmod_key_3 = &mod_switch_key_3;
  e_module_key_ctor(&mod_switch_key_3,
                      "SW_KEY_3",
                      DRV_KEY_3,
                      SIG_KEY_PRESSED,
                      SIG_KEY_RELEASED,
                      e_pmod_keyboard);

  struct e_module_report_codec mod_report_codec;
  e_pmod_report_codec = &mod_report_codec;
  e_module_report_codec_ctor(&mod_report_codec, "CODEC");

  e_core_add_module((struct e_module*) &mod_backlight);
  e_core_add_module((struct e_module*) &mod_switch_backlight);
  e_core_add_module((struct e_module*) &mod_keyboard);
  e_core_add_module((struct e_module*) &mod_switch_layout);
  e_core_add_module((struct e_module*) &mod_switch_key_1);
  e_core_add_module((struct e_module*) &mod_switch_key_2);
  e_core_add_module((struct e_module*) &mod_switch_key_3);
  e_core_add_module((struct e_module*) &mod_report_codec);

  e_core_loop();
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL3;
  RCC_OscInitStruct.PLL.PREDIV = RCC_PREDIV_DIV1;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_1) != HAL_OK)
  {
    Error_Handler();
  }
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_USB;
  PeriphClkInit.UsbClockSelection = RCC_USBCLKSOURCE_PLL;

  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOF_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, LED_3_Pin|LED_2_Pin|LED_1_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pins : LED_3_Pin LED_2_Pin LED_1_Pin */
  GPIO_InitStruct.Pin = LED_3_Pin|LED_2_Pin|LED_1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : SW_BACKLIGHT_Pin SW_3_Pin SW_2_Pin SW_1_Pin */
  GPIO_InitStruct.Pin = SW_BACKLIGHT_Pin|SW_3_Pin|SW_2_Pin|SW_1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING_FALLING;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pin : SW_LAYOUT_Pin */
  GPIO_InitStruct.Pin = SW_LAYOUT_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING_FALLING;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(SW_LAYOUT_GPIO_Port, &GPIO_InitStruct);

  /* EXTI interrupt init*/
  HAL_NVIC_SetPriority(EXTI0_1_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI0_1_IRQn);

  HAL_NVIC_SetPriority(EXTI4_15_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI4_15_IRQn);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
